org.apache.felix.scrplugin

## Class Options

- java.lang.Object
- - org.apache.felix.scrplugin.Options

    public class Options
    extends Object

Options for the `SCRDescriptorGenerator`

### Constructor Summary

Constructors
Constructor and Description
`Options()`

### Method Summary

All Methods Instance Methods Concrete Methods
`File` `getComponentDescriptorDirectory()` Convenience method to get the component descriptor directory.
`File` `getMetaTypeDirectory()` Convenience method to get the meta type directory.
`File` `getOutputDirectory()`
`Map<String,String>` `getProperties()`
`SpecVersion` `getSpecVersion()`
`boolean` `isGenerateAccessors()`
`boolean` `isIncremental()` Is this an incremental build
`boolean` `isSkipVolatileCheck()` Should the check for volatile fields be skipped?
`boolean` `isStrictMode()`
`void` `setGenerateAccessors(boolean generateAccessors)` Defines whether bind and unbind methods are automatically created by the SCR descriptor generator.
`void` `setIncremental(boolean incremental)` Set whether this is an incremental build
`void` `setOutputDirectory(File outputDirectory)` Sets the directory where the descriptor files will be created.
`void` `setProperties(Map<String,String> properties)` Sets global properties to be set for each descriptor.
`void` `setSkipVolatileCheck(boolean skipVolatileCheck)` Set whether the check should be skipped
`void` `setSpecVersion(SpecVersion specVersion)` Sets the Declarative Services specification version number to be forced on the declarations.
`void` `setStrictMode(boolean strictMode)` Defines whether warnings should be considered as errors and thus cause the generation process to fail.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Options

    public Options()

### Method Detail

#### isGenerateAccessors

    public boolean isGenerateAccessors()

Returns:
  Whether accessor methods should be generated.
See Also:
  `setGenerateAccessors(boolean)`

#### setGenerateAccessors

    public void setGenerateAccessors(boolean generateAccessors)

Defines whether bind and unbind methods are automatically created by the SCR descriptor generator.

The generator uses the ASM library to create the method byte codes directly inside the class files. If bind and unbind methods are not to be created, the generator fails if such methods are missing.

The default value of this property is `true`.

#### isStrictMode

    public boolean isStrictMode()

Returns:
  Whether strict mode should be used or not.
See Also:
  `setStrictMode(boolean)`

#### setStrictMode

    public void setStrictMode(boolean strictMode)

Defines whether warnings should be considered as errors and thus cause the generation process to fail.

The default value of this property is `false`.

#### getProperties

    public Map<String,String> getProperties()

#### setProperties

    public void setProperties(Map<String,String> properties)

Sets global properties to be set for each descriptor. If a descriptor provides properties of the same name, the descriptor properties are preferred over the properties provided here.

The are no default global properties.

#### getSpecVersion

    public SpecVersion getSpecVersion()

Returns:
  Return the requested spec version
See Also:
  `setSpecVersion(SpecVersion)`

#### setSpecVersion

    public void setSpecVersion(SpecVersion specVersion)

Sets the Declarative Services specification version number to be forced on the declarations.

Supported values for this property are `null` to autodetect the specification version, or one of the enum values from `SpecVersion`.

The default is to generate the descriptor version according to the capabilities used by the descriptors. If no 1.1 capabilities, such as `configuration-policy`, are used, version 1.0 is used, otherwise a 1.1 descriptor is generated.

#### getOutputDirectory

    public File getOutputDirectory()

Returns:
  The output directory for the generated files.
See Also:
  `setOutputDirectory(File)`

#### setOutputDirectory

    public void setOutputDirectory(File outputDirectory)

Sets the directory where the descriptor files will be created.

This field has no default value and this setter must called before passing this object to `SCRDescriptorGenerator.setOptions(Options)`.

#### getMetaTypeDirectory

    public File getMetaTypeDirectory()

Convenience method to get the meta type directory.

#### getComponentDescriptorDirectory

    public File getComponentDescriptorDirectory()

Convenience method to get the component descriptor directory.

#### isIncremental

    public boolean isIncremental()

Is this an incremental build

#### setIncremental

    public void setIncremental(boolean incremental)

Set whether this is an incremental build

#### isSkipVolatileCheck

    public boolean isSkipVolatileCheck()

Should the check for volatile fields be skipped?

#### setSkipVolatileCheck

    public void setSkipVolatileCheck(boolean skipVolatileCheck)

Set whether the check should be skipped